Shape Alignment

SpreadJS makes it easy to fine-tune multiple shape's positions using shape alignment options, distribution options or snapping them to other shapes or grids.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

You can align shapes using the following code:

    var commandManager = spread.commandManager();
    commandManager.execute({
        cmd: 'moveShapesByHAlign',
        sheetName: sheet.name(),
        shapeNames: ['rect1','line1','heart1','group1'],
        alignment: GC.Spread.Sheets.Shapes.HorizontalAlign.left
    });
    commandManager.execute({
        cmd: 'moveShapesByVAlign',
        sheetName: sheet.name(),
        shapeNames: ['rect1','line1','heart1','group1'],
        alignment: GC.Spread.Sheets.Shapes.VerticalAlign.bottom
    });
    commandManager.execute({
            cmd: 'moveShapesByHDistribute',
            sheetName: sheet.name(),
            shapeNames: ['rect1','line1','heart1','group1']
        });
    });
    commandManager.execute({
            cmd: 'moveShapesByVDistribute',
            sheetName: sheet.name(),
            shapeNames: ['rect1','line1','heart1','group1']
        });
    });

You can change snapMode to align shapes easily

    var sheet = spread.getActiveSheet();
    sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid);

Now when you drag or resize a shape, the shape will align to grid lines automatically.

You can also align to other shapes:

    var sheet = spread.getActiveSheet();
    sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid | GC.Spread.Sheets.Shapes.SnapMode.shape);
You can align shapes using the following code: You can change snapMode to align shapes easily Now when you drag or resize a shape, the shape will align to grid lines automatically. You can also align to other shapes:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 }); initSpread(spread); }; function initSpread(spread) { let sheet = spread.getActiveSheet(); var rect1 = sheet.shapes.add('rect1', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 50, 230, 100); var rect2 = sheet.shapes.add('rect2', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 200, 200, 150, 100); var rect3 = sheet.shapes.add('rect3', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 500, 300, 200, 100); spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () { shapeSelectionChangedHandler(spread); }); document.querySelectorAll('.align').forEach(function (btn) { btn.addEventListener('click', function (e) { let activeSheet = spread.getActiveSheet(); let activeShapes = activeSheet.shapes.all().filter(function (sp) { return sp.isSelected(); }); let classNames = e.target.className.split(' '); let cmd = classNames[1]; let alignment = classNames[2]; var commandManager = spread.commandManager(); commandManager.execute({ cmd: cmd, sheetName: activeSheet.name(), shapeNames: activeShapes.map(function (s) { return s.name(); }), alignment: getAlignmentEnum(alignment) }); }); }); document.querySelectorAll('.align-dd').forEach(function (dd) { dd.addEventListener('change', function (e) { let activeSheet = spread.getActiveSheet(); let activeShapes = activeSheet.shapes.all().filter(function (sp) { return sp.isSelected(); }); let classNames = e.target.className.split(' '); let cmd = classNames[1]; var commandManager = spread.commandManager(); commandManager.execute({ cmd: cmd, sheetName: activeSheet.name(), shapeNames: activeShapes.map(function (s) { return s.name(); }), alignment: getAlignmentEnum(e.target.value) }); }); }); document.querySelector('#changeSnapMode').addEventListener('change', function (e) { let sheet = spread.getActiveSheet(); switch (e.target.value) { case '0': sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.none); return; case '1': sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid); return; case '2': sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.shape); return; case '3': sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid | GC.Spread.Sheets.Shapes.SnapMode.shape); return; default: return; } }); shapeSelectionChangedHandler(spread); } function toggleEnable(enable, className) { document.querySelectorAll('.' + className).forEach(function (btn) { if (enable) { btn.removeAttribute('disabled'); } else { btn.setAttribute('disabled', ''); } }) } function getAlignmentEnum(alignment) { switch (alignment) { case 'left': return GC.Spread.Sheets.Shapes.HorizontalAlign.left; case 'center': return GC.Spread.Sheets.Shapes.HorizontalAlign.center; case 'right': return GC.Spread.Sheets.Shapes.HorizontalAlign.right; case 'top': return GC.Spread.Sheets.Shapes.VerticalAlign.top; case 'middle': return GC.Spread.Sheets.Shapes.VerticalAlign.middle; case 'bottom': return GC.Spread.Sheets.Shapes.VerticalAlign.bottom; default: return; } } function _getElementById(id) { return document.getElementById(id); } function shapeSelectionChangedHandler(spread) { let activeSheet = spread.getActiveSheet(); let shapes = activeSheet.shapes.all(), activeShapes = []; for (let i = 0; i < shapes.length; i++) { let shape = shapes[i]; if (shape.isSelected()) { activeShapes.push(shape); } } if (activeShapes.length > 1) { toggleEnable(true, 'justify'); } else { toggleEnable(false, 'justify'); } if (activeShapes.length > 2) { toggleEnable(true, 'distribute'); } else { toggleEnable(false, 'distribute'); } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> Select two or more shapes then change the different alignment options below to see the effects. </div> <div class="option-row"> *for the vertical and horizontal distribution, all three shapes must be selected. </div> <div class="option-row"> <label>- Horizontal Alignment</label> <hr> <select id="moveShapesByHAlign" class="align-dd moveShapesByHAlign"> <option value="left" selected>left</option> <option value="center">center</option> <option value="right">right</option> </select> <br /> <br /> <label>Horizontal Distribute Selected Shapes</label> <input type="button" class="align moveShapesByHDistribute distribute" value="Horizontal"> <br /> <label>- Vertical Alignment</label> <hr> <select id="moveShapesByVAlign" class="align-dd moveShapesByVAlign"> <option value="top" selected>top</option> <option value="middle">middle</option> <option value="bottom">bottom</option> </select> <br /> <br /> <label>Vertical Distribute Selected Shapes</label> <input type="button" class="align moveShapesByVDistribute distribute" value="Vertical"> <br /> <label>Change the SnapMode options to align, drag, or resize shapes to the nearest edge based on gridlines or other shapes in the worksheet. </label> <hr> <select id="changeSnapMode"> <option value="0" selected>none</option> <option value="1">grid</option> <option value="2">shape</option> <option value="3">grid and shape</option> </select> <br /> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 350px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 350px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 5px; } .sample-options { z-index: 1000; } label { display: block; margin-bottom: 6px; } p{ padding:2px 10px; background-color:#F4F8EB; } input { padding: 4px 6px; width: 160px; } input[type=button] { margin-top: 6px; display: block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

You can align shapes using the following code:
You can change snapMode to align shapes easily
Now when you drag or resize a shape, the shape will align to grid lines automatically.
You can also align to other shapes:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-shapes";
let spread = null;
export function AppFunc() {
const [alignmentOption, setAlignmentOption] = React.useState({
canAlign: false,
canDistribute: false
});
const initSpread = (currSpread) => {
spread = currSpread;
let sheet = spread.getActiveSheet();
var rect1 = sheet.shapes.add('rect1', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 50, 230, 100);
var rect2 = sheet.shapes.add('rect2', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 200, 200, 150, 100);
var rect3 = sheet.shapes.add('rect3', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 500, 300, 200, 100);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(), activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
const newAlignmentOption = {};
newAlignmentOption.canAlign = activeShapes.length > 1;
newAlignmentOption.canDistribute = activeShapes.length > 2;
setAlignmentOption(newAlignmentOption);
});
}
const align = (cmd, alignment) => {
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function (s) {
return s.name();
}),
alignment: getAlignmentEnum(alignment)
});
}
const alignDd = (e, cmd) => {
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function (s) {
return s.name();
}),
alignment: getAlignmentEnum(e.target.value)
});
}
const getAlignmentEnum = (alignment) => {
switch (alignment) {
case 'left':
return GC.Spread.Sheets.Shapes.HorizontalAlign.left;
case 'center':
return GC.Spread.Sheets.Shapes.HorizontalAlign.center;
case 'right':
return GC.Spread.Sheets.Shapes.HorizontalAlign.right;
case 'top':
return GC.Spread.Sheets.Shapes.VerticalAlign.top;
case 'middle':
return GC.Spread.Sheets.Shapes.VerticalAlign.middle;
case 'bottom':
return GC.Spread.Sheets.Shapes.VerticalAlign.bottom;
default:
return;
}
}
const changeSnapMode = (e) => {
let sheet = spread.getActiveSheet();
switch (e.target.value) {
case '0':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.none);
return;
case '1':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid);
return;
case '2':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
case '3':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid | GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
default:
return;
}
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div class="option-row">
Select two or more shapes then change the different alignment options below to see the effects.
</div>
<div class="option-row">
*for the vertical and horizontal distribution, all three shapes must be selected.
</div>
<div class="option-row">
<label>- Horizontal Alignment</label>
<hr />
<select disabled={!alignmentOption.canAlign} onChange={($event) => {alignDd($event, 'moveShapesByHAlign'); }}>
<option value="left">left</option>
<option value="center">center</option>
<option value="right">right</option>
</select>
<br /> <br />
</div>
<div class="option-row">
<label>Horizontal Distribute Selected Shapes</label>
<input type="button" disabled={!alignmentOption.canDistribute} value="horizontal" onClick={() => { align('moveShapesByHDistribute'); }}></input>
</div>
<div class="option-row">
<label>- Vertical Alignment</label>
<hr />
<select disabled={!alignmentOption.canAlign} onChange={($event) => {alignDd($event, 'moveShapesByVAlign'); }}>
<option value="top">top</option>
<option value="middle">middle</option>
<option value="bottom">bottom</option>
</select>
<br /> <br />
<label>Vertical Distribute Selected Shapes</label>
<input type="button" disabled={!alignmentOption.canDistribute} value="vertical" onClick={() => { align('moveShapesByVDistribute'); }}></input>
</div>
<div class="option-row">
<label>Change the SnapMode options to align, drag, or resize shapes to the nearest edge based on gridlines or other shapes in the worksheet. </label>
<select id="changeSnapMode" onChange={($event) => {changeSnapMode($event); }}>
<option value="0" selected>none</option>
<option value="1">grid</option>
<option value="2">shape</option>
<option value="3">grid and shape</option>
</select>
</div>
</div>
</div>);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-shapes";
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
canAlign: false,
canDistribute: false
}
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div class="option-row">
Select two or more shapes then change the different alignment options below to see the effects.
</div>
<div class="option-row">
*for the vertical and horizontal distribution, all three shapes must be selected.
</div>
<div class="option-row">
<label>- Horizontal Alignment</label>
<hr />
<select disabled={!this.state.canAlign} onChange={($event) => {this.alignDd($event, 'moveShapesByHAlign'); }}>
<option value="left">left</option>
<option value="center">center</option>
<option value="right">right</option>
</select>
<br /> <br />
</div>
<div class="option-row">
<label>Horizontal Distribute Selected Shapes</label>
<input type="button" disabled={!this.state.canDistribute} value="horizontal" onClick={() => { this.align('moveShapesByHDistribute'); }}></input>
</div>
<div class="option-row">
<label>- Vertical Alignment</label>
<hr />
<select disabled={!this.state.canAlign} onChange={($event) => {this.alignDd($event, 'moveShapesByVAlign'); }}>
<option value="top">top</option>
<option value="middle">middle</option>
<option value="bottom">bottom</option>
</select>
<br /> <br />
<label>Vertical Distribute Selected Shapes</label>
<input type="button" disabled={!this.state.canDistribute} value="vertical" onClick={() => { this.align('moveShapesByVDistribute'); }}></input>
</div>
<div class="option-row">
<label>Change the SnapMode options to align, drag, or resize shapes to the nearest edge based on gridlines or other shapes in the worksheet. </label>
<select id="changeSnapMode" onChange={($event) => {this.changeSnapMode($event); }}>
<option value="0" selected>none</option>
<option value="1">grid</option>
<option value="2">shape</option>
<option value="3">grid and shape</option>
</select>
</div>
</div>
</div>);
}
initSpread(spread) {
let self = this;
self.spread = spread;
let sheet = spread.getActiveSheet();
var rect1 = sheet.shapes.add('rect1', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 50, 230, 100);
var rect2 = sheet.shapes.add('rect2', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 200, 200, 150, 100);
var rect3 = sheet.shapes.add('rect3', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 500, 300, 200, 100);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(), activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length > 1) {
self.setState({ canAlign: true });
} else {
self.setState({ canAlign: false });
}
if (activeShapes.length > 2) {
self.setState({ canDistribute: true });
} else {
self.setState({ canDistribute: false });
}
});
}
align(cmd, alignment) {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function (s) {
return s.name();
}),
alignment: self.getAlignmentEnum(alignment)
});
}
alignDd(e, cmd){
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function (s) {
return s.name();
}),
alignment: self.getAlignmentEnum(e.target.value)
});
}
getAlignmentEnum(alignment) {
switch (alignment) {
case 'left':
return GC.Spread.Sheets.Shapes.HorizontalAlign.left;
case 'center':
return GC.Spread.Sheets.Shapes.HorizontalAlign.center;
case 'right':
return GC.Spread.Sheets.Shapes.HorizontalAlign.right;
case 'top':
return GC.Spread.Sheets.Shapes.VerticalAlign.top;
case 'middle':
return GC.Spread.Sheets.Shapes.VerticalAlign.middle;
case 'bottom':
return GC.Spread.Sheets.Shapes.VerticalAlign.bottom;
default:
return;
}
}
changeSnapMode(e) {
let self = this, spread = self.spread;
let sheet = spread.getActiveSheet();
switch (e.target.value) {
case '0':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.none);
return;
case '1':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid);
return;
case '2':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
case '3':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid | GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
default:
return;
}
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 350px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 350px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.sample-options {
z-index: 1000;
}
label {
display: block;
margin-bottom: 6px;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can align shapes using the following code:
You can change snapMode to align shapes easily
Now when you drag or resize a shape, the shape will align to grid lines automatically.
You can also align to other shapes:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Select two or more shapes then change the different alignment options below to see the effects.
alignment to see the effect.
</div>
<div class="option-row">
*for the vertical and horizontal distribution, all three shapes must be selected.
</div>
<div class="option-row">
<label>- Horizontal Alignment</label>
<hr>
<select id="moveShapesByHAlign" :disabled="!canAlign" @change="alignDd($event,'moveShapesByHAlign')">
<option value="left">left</option>
<option value="center">center</option>
<option value="right">right</option>
</select>
<br />
</div>
<div class="option-row">
<label>Horizontal Distribute Selected Shapes</label>
<input type="button" :disabled="!canDistribute" value="Horizontal" @click="align('moveShapesByHDistribute')" />
<br />
</div>
<div class="option-row">
<label>- Vertical Alignment</label>
<hr>
<select id="moveShapesByVAlign" :disabled="!canAlign" @change="alignDd($event,'moveShapesByVAlign')">
<option value="top">top</option>
<option value="middle">middle</option>
<option value="bottom">bottom</option>
</select>
<br />
</div>
<div class="option-row">
<label>Vertical Distribute Selected Shapes</label>
<input type="button" :disabled="!canDistribute" value="Vertical" @click="align('moveShapesByVDistribute')" />
<br />
</div>
<div class="option-row">
<label>Change the SnapMode options to align, drag, or resize shapes to the nearest edge based on gridlines or other shapes in the worksheet. </label>
<select id="changeSnapMode" @change="changeSnapMode($event)">
<option value="0" selected>none</option>
<option value="1">grid</option>
<option value="2">shape</option>
<option value="3">grid and shape</option>
</select>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import { ref } from 'vue';
const spreadRef = ref(null);
const canAlign = ref(false);
const canDistribute = ref(false);
function initSpread(spread) {
spreadRef.value = spread;
let sheet = spread.getActiveSheet();
var rect1 = sheet.shapes.add(
"rect1",
GC.Spread.Sheets.Shapes.AutoShapeType.rectangle,
100,
50,
230,
100
);
var rect2 = sheet.shapes.add(
"rect2",
GC.Spread.Sheets.Shapes.AutoShapeType.rectangle,
200,
200,
150,
100
);
var rect3 = sheet.shapes.add(
"rect3",
GC.Spread.Sheets.Shapes.AutoShapeType.rectangle,
500,
300,
200,
100
);
spread.bind(
GC.Spread.Sheets.Events.ShapeSelectionChanged,
function () {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(),
activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length > 1) {
canAlign.value = true;
} else {
canAlign.value = false;
}
if (activeShapes.length > 2) {
canDistribute.value = true;
} else {
canDistribute.value = false;
}
}
);
}
function align(cmd, alignment) {
const spread = spreadRef.value;
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function (s) {
return s.name();
}),
alignment: getAlignmentEnum(alignment),
});
}
function alignDd(e, cmd) {
const spread = spreadRef.value;
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function (s) {
return s.name();
}),
alignment: getAlignmentEnum(e.target.value),
});
}
function getAlignmentEnum(alignment) {
switch (alignment) {
case "left":
return GC.Spread.Sheets.Shapes.HorizontalAlign.left;
case "center":
return GC.Spread.Sheets.Shapes.HorizontalAlign.center;
case "right":
return GC.Spread.Sheets.Shapes.HorizontalAlign.right;
case "top":
return GC.Spread.Sheets.Shapes.VerticalAlign.top;
case "middle":
return GC.Spread.Sheets.Shapes.VerticalAlign.middle;
case "bottom":
return GC.Spread.Sheets.Shapes.VerticalAlign.bottom;
}
}
function changeSnapMode(e) {
let sheet = spreadRef.value.getActiveSheet();
switch (e.target.value) {
case '0':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.none);
return;
case '1':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid);
return;
case '2':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
case '3':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid | GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
default:
return;
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 350px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 350px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-container {
float: right;
width: 350px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.sample-options {
z-index: 1000;
}
label {
display: block;
margin-bottom: 6px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type="button"] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can align shapes using the following code:
You can change snapMode to align shapes easily
Now when you drag or resize a shape, the shape will align to grid lines automatically.
You can also align to other shapes:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 350px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
canAlign = false;
canDistribute = false;
align(cmd: string, alignment: string) {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function(s: GC.Spread.Sheets.Shapes.Shape) {
return s.name();
}),
alignment: self.getAlignmentEnum(alignment)
});
}
alignDd(e: any,cmd: string): void {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShapes = activeSheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
var commandManager = spread.commandManager();
commandManager.execute({
cmd: cmd,
sheetName: activeSheet.name(),
shapeNames: activeShapes.map(function(s: GC.Spread.Sheets.Shapes.Shape) {
return s.name();
}),
alignment: self.getAlignmentEnum(e.target.value)
});
}
getAlignmentEnum(alignment: string) {
switch (alignment) {
case 'left':
return GC.Spread.Sheets.Shapes.HorizontalAlign.left;
case 'center':
return GC.Spread.Sheets.Shapes.HorizontalAlign.center;
case 'right':
return GC.Spread.Sheets.Shapes.HorizontalAlign.right;
case 'top':
return GC.Spread.Sheets.Shapes.VerticalAlign.top;
case 'middle':
return GC.Spread.Sheets.Shapes.VerticalAlign.middle;
case 'bottom':
return GC.Spread.Sheets.Shapes.VerticalAlign.bottom;
default:
return;
}
}
initSpread($event: any) {
let spread = $event.spread, self = this;
self.spread = spread;
let sheet = spread.getActiveSheet();
var rect1 = sheet.shapes.add('rect1', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 50, 230, 100);
var rect2 = sheet.shapes.add('rect2', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 200, 200, 150, 100);
var rect3 = sheet.shapes.add('rect3', GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 500, 350, 200, 100);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function() {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(), activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length > 1) {
self.canAlign = true;
} else {
self.canAlign = false;
}
if (activeShapes.length > 2) {
self.canDistribute = true;
} else {
self.canDistribute = false;
}
});
}
changeSnapMode(e: any): void {
let sheet = this.spread.getActiveSheet();
switch (e.target.value) {
case '0':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.none);
return;
case '1':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid);
return;
case '2':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
case '3':
sheet.shapes.snapMode(GC.Spread.Sheets.Shapes.SnapMode.grid | GC.Spread.Sheets.Shapes.SnapMode.shape);
return;
default:
return;
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Select two or more shapes then change the different alignment options below to see the effects.
</div>
<div class="option-row">
*for the vertical and horizontal distribution, all three shapes must be selected.
</div>
<div class="option-row">
<label>- Horizontal Alignment</label>
<hr>
<select id="moveShapesByHAlign" [disabled]="!canAlign" (change)="alignDd($event,'moveShapesByHAlign')">
<option value="left">left</option>
<option value="center">center</option>
<option value="right">right</option>
</select>
<br /> <br />
<div class="option-row">
<label>Horizontal Align Selected Shapes</label>
<input type="button" [disabled]="!canDistribute" value="Horizontal" (click)="align('moveShapesByHDistribute')">
</div>
<div class="option-row">
<label>- Vertical Alignment</label>
<hr>
<select id="moveShapesByVAlign" [disabled]="!canAlign" (change)="alignDd($event,'moveShapesByVAlign')">
<option value="top">top</option>
<option value="middle">middle</option>
<option value="bottom">bottom</option>
</select>
<br />
<div class="option-row">
<label>Vertical Align Selected Shapes</label>
<input type="button" [disabled]="!canDistribute" value="Vertical" (click)="align('moveShapesByVDistribute')">
</div>
<div class="option-row">
<label>Change the SnapMode options to align, drag, or resize shapes to the nearest edge based on gridlines or other shapes in the worksheet. </label>
<hr>
<select id="changeSnapMode" (change)="changeSnapMode($event)">
<option value="0" selected>none</option>
<option value="1">grid</option>
<option value="2">shape</option>
<option value="3">grid and shape</option>
</select>
<br />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
width: 100%;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 350px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.sample-options {
z-index: 1000;
}
label {
display: block;
margin-bottom: 6px;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);